/*
modstat.h
Copyright (C)2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2003 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/

#ifndef _BHMODSTAT_
#define _BHMODSTAT_

#include <list>

/*
 * @ingroup commlib Common Libraries
 * @{
 *
 */
 
namespace BhPos{

/*
 * @defgroup bhmodstat Mode Status 
 * @{
 *
 * @ingroup commlib
 * @{
 */

#define KEY_ENABLED_BASE          0x00000001
#define KEY_ENABLED_ESCAPE       (KEY_ENABLED_BASE)
#define KEY_ENABLED_RETURN       (KEY_ENABLED_BASE << 1)
#define KEY_ENABLED_NUMERIC      (KEY_ENABLED_BASE << 2)
#define KEY_ENABLED_ALPHA        (KEY_ENABLED_BASE << 3)
#define KEY_ENABLED_FUNCTION     (KEY_ENABLED_BASE << 4)
#define KEY_ENABLED_NAVIGATION   (KEY_ENABLED_BASE << 5)
#define KEY_ENABLED_EDITING      (KEY_ENABLED_BASE << 6)
#define KEY_ENABLED_MAPPED       (KEY_ENABLED_BASE << 7)
#define KEY_ENABLED_PAYMENT      (KEY_ENABLED_BASE << 8)
#define KEY_ENABLED_NUMSYM       (KEY_ENABLED_BASE << 9)
#define KEY_ENABLED_PRINT        (KEY_ENABLED_BASE << 10)
#define KEY_ENABLED_MISC         (KEY_ENABLED_BASE << 11)
#define KEY_ENABLED_TRANS        (KEY_ENABLED_BASE << 12)
#define KEY_ENABLED_MICR         (KEY_ENABLED_BASE << 13)
#define KEY_ENABLED_OPERATOR     (KEY_ENABLED_BASE << 14)
#define KEY_ENABLED_DELETE       (KEY_ENABLED_BASE << 15)
#define KEY_ENABLED_REMOVE       (KEY_ENABLED_BASE << 16)
#define KEY_ENABLED_SWAP         (KEY_ENABLED_BASE << 17)

#define KEY_ENABLE_GROUP_IDLE         (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_MISC | KEY_ENABLED_TRANS | \
                                       KEY_ENABLED_MAPPED | KEY_ENABLED_RETURN | PK_SALETYPE | \
                                       KEY_ENABLED_SWAP)
                                 
#define KEY_ENABLE_GROUP_TRANSID      (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_MISC | KEY_ENABLED_TRANS | KEY_ENABLED_RETURN)
                                      
#define KEY_ENABLE_GROUP_QUANTITY     (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN)
                                    
#define KEY_ENABLE_GROUP_SALE         (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION | \
                                       KEY_ENABLED_MAPPED | KEY_ENABLED_ALPHA | \
                                       KEY_ENABLED_MISC | KEY_ENABLED_EDITING | KEY_ENABLED_REMOVE | \
                                       KEY_ENABLED_SWAP)

#define KEY_ENABLE_GROUP_ITEMADD      (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_RETURN | KEY_ENABLED_MISC | KEY_ENABLED_EDITING )                                   
                                    
#define KEY_ENABLE_GROUP_TOTAL        (KEY_ENABLED_ESCAPE | KEY_ENABLED_PAYMENT)
                                                                        
#define KEY_ENABLE_GROUP_TENDER       (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_RETURN | KEY_ENABLED_PAYMENT | \
                                       KEY_ENABLED_EDITING)
                                       
#define KEY_ENABLE_GROUP_REMOVE       (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN)                                       
                                    
#define KEY_ENABLE_GROUP_PAYMENT       KEY_ENABLED_ESCAPE

#define KEY_ENABLE_GROUP_INEDIT       (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_EDITING | \
                                       KEY_ENABLED_NAVIGATION | KEY_ENABLED_OPERATOR | KEY_ENABLED_DELETE)
                                    
#define KEY_ENABLE_GROUP_TENDEREDIT   (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_EDITING | \
                                       KEY_ENABLED_NAVIGATION | KEY_ENABLED_DELETE)

#define KEY_ENABLE_GROUP_GENACK       (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN)

#define KEY_ENABLE_GROUP_CASHADJUST   (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_OPERATOR | \
                                       KEY_ENABLED_NAVIGATION | KEY_ENABLED_NUMERIC | KEY_ENABLED_EDITING)
                                       
#define KEY_ENABLE_GROUP_CASHADJUSTOP (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NUMERIC)

#define KEY_ENABLE_GROUP_CUSTOMERSUMM (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION)

#define KEY_ENABLE_GROUP_CUSTTRANS    (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION)

#define KEY_ENABLE_GROUP_EPHEMADD     (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION | \
                                       KEY_ENABLED_NUMERIC)
                                       
#define KEY_ENABLE_GROUP_OPENBALANCE  (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NUMERIC | \
                                       KEY_ENABLED_NAVIGATION)
                                       
#define KEY_ENABLE_GROUP_BLINDBALANCE (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NUMERIC | \
                                       KEY_ENABLED_EDITING)
                                       
#define KEY_ENABLE_GROUP_RETURNREASON (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION)

#define KEY_ENABLE_GROUP_PRICELIST    (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION)

enum BhClientStatus{
   BHCLIENT_STATUS_IDLE=0,
   BHCLIENT_STATUS_NOUSER,
   BHCLIENT_STATUS_TRANSID,
   BHCLIENT_STATUS_SALE,
   BHCLIENT_STATUS_QUANTITY,
   BHCLIENT_STATUS_INEDIT,
   BHCLIENT_STATUS_WAITONPLU,
   BHCLIENT_STATUS_TOTAL,
   BHCLIENT_STATUS_TENDERTYPE,
   BHCLIENT_STATUS_TENDERAMOUNT,
   BHCLIENT_STATUS_PAYMENT,
   BHCLIENT_STATUS_ITEMADD,
   BHCLIENT_STATUS_DRAWEROPEN,
   BHCLIENT_STATUS_UNKNOWNPLU,
   BHCLIENT_STATUS_ITEMFLAGACK,
   BHCLIENT_STATUS_WAITONPRICE,
   BHCLIENT_STATUS_PAYAUTH,
   BHCLIENT_STATUS_WAITSWIPE,
   BHCLIENT_STATUS_WAITMICR,
   BHCLIENT_STATUS_WAITCHPRINT,
   BHCLIENT_STATUS_WAITCASHD,
   BHCLIENT_STATUS_COMMIT,
   BHCLIENT_STATUS_WAITONDESC,
   BHCLIENT_STATUS_CASHADJUST,
   BHCLIENT_STATUS_CASHADJUSTADD,
   BHCLIENT_STATUS_CASHADJUSTSUB,
   BHCLIENT_STATUS_CASHADJUSTABS,
   BHCLIENT_STATUS_RETURNSADD,
   BHCLIENT_STATUS_RETURNSSUB,
   BHCLIENT_STATUS_RETURNSABS,
   BHCLIENT_STATUS_TRANSRETREIVE,
   BHCLIENT_STATUS_RETCOMMIT,
   BHCLIENT_STATUS_WAITONTAXLIST,
   BHCLIENT_STATUS_WAITONPRICELIST,
   BHCLIENT_STATUS_SERVERACK,
   BHCLIENT_STATUS_LOGOUTACK,
   BHCLIENT_STATUS_QUITACK,
   BHCLIENT_STATUS_CANCELTRANS,
   BHCLIENT_STATUS_TENDEREDIT,
   BHCLIENT_STATUS_DISCOUNT,
   BHCLIENT_STATUS_REMOVE,
   BHCLIENT_STATUS_CASHDCOMMIT,
   BHCLIENT_STATUS_WAITONSCALES,
   BHCLIENT_STATUS_DELIVERYDONE,
   BHCLIENT_STATUS_EPHEMCOMMIT,
   BHCLIENT_STATUS_EPHEMLOOKUP,
   BHCLIENT_STATUS_QUANTITYEDIT,
   BHCLIENT_STATUS_AMOUNTEDIT,
   BHCLIENT_STATUS_TRANSIDENTRY,
   BHCLIENT_STATUS_CASHBACKCHECK,
   BHCLIENT_STATUS_MICRCOMMIT,
   BHCLIENT_STATUS_WAITCHINSERT,
   BHCLIENT_STATUS_PAYIN,
   BHCLIENT_STATUS_PAYOUT,
   BHCLIENT_STATUS_ZTAPE,
   BHCLIENT_STATUS_RETURNREASON
};

enum BhClientMode{
   BHCLIENT_MODE_UNKNOWN=0,
   BHCLIENT_MODE_TRANSACTION,
   BHCLIENT_MODE_SUMMARY,
   BHCLIENT_MODE_USERSUMMARY,
   BHCLIENT_MODE_CASHADJUST,
   BHCLIENT_MODE_RETURNS,
   BHCLIENT_MODE_GOODSIN,
   BHCLIENT_MODE_RETURNSPASS,
   BHCLIENT_MODE_TRANSEDIT,
   BHCLIENT_MODE_CUSTLIST,
   BHCLIENT_MODE_LAYBYLIST,
   BHCLIENT_MODE_RENTALLIST,
   BHCLIENT_MODE_DELIVERYLIST,
   BHCLIENT_MODE_BLINDBALANCE,
   BHCLIENT_MODE_EPHEMERAL,
   BHCLIENT_MODE_CUSTTRANSTENDER,
   BHCLIENT_MODE_CUSTPAYCOMMIT,
   BHCLIENT_MODE_OPENBAL,
   BHCLIENT_MODE_RETURNREASON,
   BHCLIENT_MODE_TRANSSELECT,
   BHCLIENT_MODE_PRICESELECT
};

enum BhModStatParam{
   BHMODSTAT_MODE,
   BHMODSTAT_STATUS,
   BHMODSTAT_KEYGROUP
};

class CModeStatus
{
   int mode;
   int status;
   unsigned int keygrp;

public:
   CModeStatus();
   /*!
		CModeStatus
		\param m mode
		\param s status
      \param k keygroup
	*/
   CModeStatus(int m, int s, unsigned int k);
   ~CModeStatus();
   CModeStatus& operator=(const CModeStatus&);
   CModeStatus* operator&();
   bool operator==(CModeStatus const&);
   bool operator!=(CModeStatus const&);
   /*!
		KeyEnabled
		\param kg keygroup
		\return true if key is enabled, false otherwise.
	*/
   bool KeyEnabled(unsigned int kg);
   /*!
		Set
      \param p parameter
		\param v value
	*/
   void Set(BhModStatParam p, unsigned int v);
     
   /*!
		Set
      \param p parameter
		\return value
	*/
   unsigned int Get(BhModStatParam p);
};

class CModeStatusList
{
	std::list<CModeStatus> entry;
	
public:	
	CModeStatusList();
	~CModeStatusList();
   CModeStatusList& operator=(const CModeStatusList&);
   CModeStatusList* operator&();
   bool operator==(CModeStatusList const&);
   bool operator!=(CModeStatusList const&);
   void Clear();
	int  Push(const CModeStatus&);
	bool Pop(int *, int *, unsigned int *);
	bool Current(int *, int *, unsigned int *);
};

/* }@
	}@ */
}

/* }@ */

#endif
