/*
bhdisplay.h
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#ifndef _BHDISPLAY_H_
#define _BHDISPLAY_H_

#include <gtk--/main.h>
#include <gtk--/window.h>
#include <gtk--/drawingarea.h>
#include <gdk--/color.h>
#include <gdk--/gc.h>

namespace BhPos{

/**
 * @ingroup bhwidget Widgets
 * @{
 *
 * @ingroup commlib
 * @{	
 */

namespace Widget{
/*
 * @defgroup bhdisplay
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */

class BhDisplay : public Gtk::DrawingArea
{
private:
   int	 xsDigits[12], xeDigits[12], xdDigits[12], ydDigits;
	double number;
   
protected:
   Gdk_GC     gc;
   Gdk_Window window;
   Gdk_Pixmap final;
   Gdk_Pixmap facia;
   Gdk_Pixmap digits;
   Gdk_Pixmap neg_digits;
   Gdk_Color  transparent_color;	

	void Draw();
	
	virtual void realize_impl();
	virtual gint expose_event_impl(GdkEventExpose* e);

public:
	BhDisplay();
	~BhDisplay();
	gint Load(char *facianame, char *digitname, char *negdigitname);
	void Set(double n);
};

/* }@ 
	}@ */

}
/* }@ 
	}@ */
}

#endif // _BHDISPLAY_H_
